Index: XIOS3/trunk/src/interface/fortran_attr/idomain_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 2614)
+++ XIOS3/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 2616)
@@ -12,9 +12,10 @@
 
   SUBROUTINE xios(set_domain_attr)  &
-    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_id, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
@@ -22,4 +23,6 @@
       CHARACTER(LEN=*), INTENT(IN) ::domain_id
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_2d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d(:,:,:)
@@ -28,4 +31,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: bounds_lon_name
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_i
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_j
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim
@@ -60,4 +65,5 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: nj_glo
       INTEGER  , OPTIONAL, INTENT(IN) :: nvertex
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: nvertex_name
       INTEGER  , OPTIONAL, INTENT(IN) :: prec
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: radius
@@ -68,22 +74,26 @@
       (domain_id,domain_hdl)
       CALL xios(set_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr)
 
   SUBROUTINE xios(set_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_2d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d(:,:,:)
@@ -92,4 +102,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: bounds_lon_name
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_i
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_j
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim
@@ -124,4 +136,5 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: nj_glo
       INTEGER  , OPTIONAL, INTENT(IN) :: nvertex
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: nvertex_name
       INTEGER  , OPTIONAL, INTENT(IN) :: prec
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: radius
@@ -130,23 +143,26 @@
 
       CALL xios(set_domain_attr_hdl_)  &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr_hdl)
 
   SUBROUTINE xios(set_domain_attr_hdl_)   &
-    ( domain_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_, bounds_lon_2d_  &
-    , bounds_lon_name_, comment_, data_dim_, data_i_index_, data_ibegin_, data_j_index_, data_jbegin_  &
-    , data_ni_, data_nj_, dim_i_name_, dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_  &
-    , lat_name_, latvalue_1d_, latvalue_2d_, lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_  &
-    , mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_, nvertex_, prec_, radius_, standard_name_, type_  &
-     )
+    ( domain_hdl, area_, area_1d_, area_2d_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_  &
+    , bounds_lon_2d_, bounds_lon_name_, chunking_weight_i_, chunking_weight_j_, comment_, data_dim_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, dim_i_name_  &
+    , dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_, lat_name_, latvalue_1d_, latvalue_2d_  &
+    , lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, nvertex_name_, prec_, radius_, standard_name_, type_ )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_2d_(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d_(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d_(:,:,:)
@@ -155,4 +171,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d_(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: bounds_lon_name_
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_i_
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: chunking_weight_j_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment_
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim_
@@ -187,4 +205,5 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: nj_glo_
       INTEGER  , OPTIONAL, INTENT(IN) :: nvertex_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: nvertex_name_
       INTEGER  , OPTIONAL, INTENT(IN) :: prec_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: radius_
@@ -197,4 +216,14 @@
       ENDIF
 
+      IF (PRESENT(area_1d_)) THEN
+        CALL cxios_set_domain_area_1d &
+      (domain_hdl%daddr, area_1d_, SHAPE(area_1d_))
+      ENDIF
+
+      IF (PRESENT(area_2d_)) THEN
+        CALL cxios_set_domain_area_2d &
+      (domain_hdl%daddr, area_2d_, SHAPE(area_2d_))
+      ENDIF
+
       IF (PRESENT(bounds_lat_1d_)) THEN
         CALL cxios_set_domain_bounds_lat_1d &
@@ -225,4 +254,14 @@
         CALL cxios_set_domain_bounds_lon_name &
       (domain_hdl%daddr, bounds_lon_name_, len(bounds_lon_name_))
+      ENDIF
+
+      IF (PRESENT(chunking_weight_i_)) THEN
+        CALL cxios_set_domain_chunking_weight_i &
+      (domain_hdl%daddr, chunking_weight_i_)
+      ENDIF
+
+      IF (PRESENT(chunking_weight_j_)) THEN
+        CALL cxios_set_domain_chunking_weight_j &
+      (domain_hdl%daddr, chunking_weight_j_)
       ENDIF
 
@@ -381,4 +420,9 @@
       ENDIF
 
+      IF (PRESENT(nvertex_name_)) THEN
+        CALL cxios_set_domain_nvertex_name &
+      (domain_hdl%daddr, nvertex_name_, len(nvertex_name_))
+      ENDIF
+
       IF (PRESENT(prec_)) THEN
         CALL cxios_set_domain_prec &
@@ -404,9 +448,10 @@
 
   SUBROUTINE xios(get_domain_attr)  &
-    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_id, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
@@ -414,4 +459,6 @@
       CHARACTER(LEN=*), INTENT(IN) ::domain_id
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_2d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d(:,:,:)
@@ -420,4 +467,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: bounds_lon_name
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_i
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_j
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim
@@ -452,4 +501,5 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: nj_glo
       INTEGER  , OPTIONAL, INTENT(OUT) :: nvertex
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: nvertex_name
       INTEGER  , OPTIONAL, INTENT(OUT) :: prec
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: radius
@@ -460,22 +510,26 @@
       (domain_id,domain_hdl)
       CALL xios(get_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr)
 
   SUBROUTINE xios(get_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_2d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d(:,:,:)
@@ -484,4 +538,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: bounds_lon_name
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_i
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_j
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim
@@ -516,4 +572,5 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: nj_glo
       INTEGER  , OPTIONAL, INTENT(OUT) :: nvertex
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: nvertex_name
       INTEGER  , OPTIONAL, INTENT(OUT) :: prec
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: radius
@@ -522,23 +579,26 @@
 
       CALL xios(get_domain_attr_hdl_)  &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr_hdl)
 
   SUBROUTINE xios(get_domain_attr_hdl_)   &
-    ( domain_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_, bounds_lon_2d_  &
-    , bounds_lon_name_, comment_, data_dim_, data_i_index_, data_ibegin_, data_j_index_, data_jbegin_  &
-    , data_ni_, data_nj_, dim_i_name_, dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_  &
-    , lat_name_, latvalue_1d_, latvalue_2d_, lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_  &
-    , mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_, nvertex_, prec_, radius_, standard_name_, type_  &
-     )
+    ( domain_hdl, area_, area_1d_, area_2d_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_  &
+    , bounds_lon_2d_, bounds_lon_name_, chunking_weight_i_, chunking_weight_j_, comment_, data_dim_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, dim_i_name_  &
+    , dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_, lat_name_, latvalue_1d_, latvalue_2d_  &
+    , lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, nvertex_name_, prec_, radius_, standard_name_, type_ )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_2d_(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d_(:,:)
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d_(:,:,:)
@@ -547,4 +607,6 @@
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d_(:,:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: bounds_lon_name_
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_i_
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: chunking_weight_j_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment_
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim_
@@ -579,4 +641,5 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: nj_glo_
       INTEGER  , OPTIONAL, INTENT(OUT) :: nvertex_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: nvertex_name_
       INTEGER  , OPTIONAL, INTENT(OUT) :: prec_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: radius_
@@ -589,4 +652,14 @@
       ENDIF
 
+      IF (PRESENT(area_1d_)) THEN
+        CALL cxios_get_domain_area_1d &
+      (domain_hdl%daddr, area_1d_, SHAPE(area_1d_))
+      ENDIF
+
+      IF (PRESENT(area_2d_)) THEN
+        CALL cxios_get_domain_area_2d &
+      (domain_hdl%daddr, area_2d_, SHAPE(area_2d_))
+      ENDIF
+
       IF (PRESENT(bounds_lat_1d_)) THEN
         CALL cxios_get_domain_bounds_lat_1d &
@@ -617,4 +690,14 @@
         CALL cxios_get_domain_bounds_lon_name &
       (domain_hdl%daddr, bounds_lon_name_, len(bounds_lon_name_))
+      ENDIF
+
+      IF (PRESENT(chunking_weight_i_)) THEN
+        CALL cxios_get_domain_chunking_weight_i &
+      (domain_hdl%daddr, chunking_weight_i_)
+      ENDIF
+
+      IF (PRESENT(chunking_weight_j_)) THEN
+        CALL cxios_get_domain_chunking_weight_j &
+      (domain_hdl%daddr, chunking_weight_j_)
       ENDIF
 
@@ -773,4 +856,9 @@
       ENDIF
 
+      IF (PRESENT(nvertex_name_)) THEN
+        CALL cxios_get_domain_nvertex_name &
+      (domain_hdl%daddr, nvertex_name_, len(nvertex_name_))
+      ENDIF
+
       IF (PRESENT(prec_)) THEN
         CALL cxios_get_domain_prec &
@@ -796,9 +884,10 @@
 
   SUBROUTINE xios(is_defined_domain_attr)  &
-    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_id, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
@@ -807,4 +896,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: area
       LOGICAL(KIND=C_BOOL) :: area_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_1d
+      LOGICAL(KIND=C_BOOL) :: area_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_2d
+      LOGICAL(KIND=C_BOOL) :: area_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_1d
       LOGICAL(KIND=C_BOOL) :: bounds_lat_1d_tmp
@@ -819,4 +912,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_name
       LOGICAL(KIND=C_BOOL) :: bounds_lon_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_i
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_i_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_j
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_j_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: comment
       LOGICAL(KIND=C_BOOL) :: comment_tmp
@@ -879,4 +976,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex
       LOGICAL(KIND=C_BOOL) :: nvertex_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex_name
+      LOGICAL(KIND=C_BOOL) :: nvertex_name_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: prec
       LOGICAL(KIND=C_BOOL) :: prec_tmp
@@ -891,18 +990,20 @@
       (domain_id,domain_hdl)
       CALL xios(is_defined_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(is_defined_domain_attr)
 
   SUBROUTINE xios(is_defined_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-    , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-    , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-    , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-    , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+    ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+    , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+    , prec, radius, standard_name, type )
 
     IMPLICIT NONE
@@ -910,4 +1011,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: area
       LOGICAL(KIND=C_BOOL) :: area_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_1d
+      LOGICAL(KIND=C_BOOL) :: area_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_2d
+      LOGICAL(KIND=C_BOOL) :: area_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_1d
       LOGICAL(KIND=C_BOOL) :: bounds_lat_1d_tmp
@@ -922,4 +1027,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_name
       LOGICAL(KIND=C_BOOL) :: bounds_lon_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_i
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_i_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_j
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_j_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: comment
       LOGICAL(KIND=C_BOOL) :: comment_tmp
@@ -982,4 +1091,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex
       LOGICAL(KIND=C_BOOL) :: nvertex_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex_name
+      LOGICAL(KIND=C_BOOL) :: nvertex_name_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: prec
       LOGICAL(KIND=C_BOOL) :: prec_tmp
@@ -992,19 +1103,20 @@
 
       CALL xios(is_defined_domain_attr_hdl_)  &
-      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d, bounds_lon_2d  &
-      , bounds_lon_name, comment, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni  &
-      , data_nj, dim_i_name, dim_j_name, domain_ref, i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d  &
-      , latvalue_2d, lon_name, long_name, lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo  &
-      , nj, nj_glo, nvertex, prec, radius, standard_name, type )
+      ( domain_hdl, area, area_1d, area_2d, bounds_lat_1d, bounds_lat_2d, bounds_lat_name, bounds_lon_1d  &
+      , bounds_lon_2d, bounds_lon_name, chunking_weight_i, chunking_weight_j, comment, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, dim_i_name, dim_j_name, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, lat_name, latvalue_1d, latvalue_2d, lon_name, long_name  &
+      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, nvertex_name  &
+      , prec, radius, standard_name, type )
 
   END SUBROUTINE xios(is_defined_domain_attr_hdl)
 
   SUBROUTINE xios(is_defined_domain_attr_hdl_)   &
-    ( domain_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_, bounds_lon_2d_  &
-    , bounds_lon_name_, comment_, data_dim_, data_i_index_, data_ibegin_, data_j_index_, data_jbegin_  &
-    , data_ni_, data_nj_, dim_i_name_, dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_  &
-    , lat_name_, latvalue_1d_, latvalue_2d_, lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_  &
-    , mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_, nvertex_, prec_, radius_, standard_name_, type_  &
-     )
+    ( domain_hdl, area_, area_1d_, area_2d_, bounds_lat_1d_, bounds_lat_2d_, bounds_lat_name_, bounds_lon_1d_  &
+    , bounds_lon_2d_, bounds_lon_name_, chunking_weight_i_, chunking_weight_j_, comment_, data_dim_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, dim_i_name_  &
+    , dim_j_name_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_, lat_name_, latvalue_1d_, latvalue_2d_  &
+    , lon_name_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, nvertex_name_, prec_, radius_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -1012,4 +1124,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: area_
       LOGICAL(KIND=C_BOOL) :: area__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_1d_
+      LOGICAL(KIND=C_BOOL) :: area_1d__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: area_2d_
+      LOGICAL(KIND=C_BOOL) :: area_2d__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_1d_
       LOGICAL(KIND=C_BOOL) :: bounds_lat_1d__tmp
@@ -1024,4 +1140,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_name_
       LOGICAL(KIND=C_BOOL) :: bounds_lon_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_i_
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_i__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: chunking_weight_j_
+      LOGICAL(KIND=C_BOOL) :: chunking_weight_j__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: comment_
       LOGICAL(KIND=C_BOOL) :: comment__tmp
@@ -1084,4 +1204,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex_
       LOGICAL(KIND=C_BOOL) :: nvertex__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nvertex_name_
+      LOGICAL(KIND=C_BOOL) :: nvertex_name__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: prec_
       LOGICAL(KIND=C_BOOL) :: prec__tmp
@@ -1099,4 +1221,16 @@
       ENDIF
 
+      IF (PRESENT(area_1d_)) THEN
+        area_1d__tmp = cxios_is_defined_domain_area_1d &
+      (domain_hdl%daddr)
+        area_1d_ = area_1d__tmp
+      ENDIF
+
+      IF (PRESENT(area_2d_)) THEN
+        area_2d__tmp = cxios_is_defined_domain_area_2d &
+      (domain_hdl%daddr)
+        area_2d_ = area_2d__tmp
+      ENDIF
+
       IF (PRESENT(bounds_lat_1d_)) THEN
         bounds_lat_1d__tmp = cxios_is_defined_domain_bounds_lat_1d &
@@ -1135,4 +1269,16 @@
       ENDIF
 
+      IF (PRESENT(chunking_weight_i_)) THEN
+        chunking_weight_i__tmp = cxios_is_defined_domain_chunking_weight_i &
+      (domain_hdl%daddr)
+        chunking_weight_i_ = chunking_weight_i__tmp
+      ENDIF
+
+      IF (PRESENT(chunking_weight_j_)) THEN
+        chunking_weight_j__tmp = cxios_is_defined_domain_chunking_weight_j &
+      (domain_hdl%daddr)
+        chunking_weight_j_ = chunking_weight_j__tmp
+      ENDIF
+
       IF (PRESENT(comment_)) THEN
         comment__tmp = cxios_is_defined_domain_comment &
@@ -1315,4 +1461,10 @@
       ENDIF
 
+      IF (PRESENT(nvertex_name_)) THEN
+        nvertex_name__tmp = cxios_is_defined_domain_nvertex_name &
+      (domain_hdl%daddr)
+        nvertex_name_ = nvertex_name__tmp
+      ENDIF
+
       IF (PRESENT(prec_)) THEN
         prec__tmp = cxios_is_defined_domain_prec &
